//ILDA32.JS docsize:LENGTH Thursday June 30th   2022 02:44:50 PM EDT
var ver='2.6.14N';
//- SPIFFs Size -- Total: 173441 Used: 133281 Free: 40160
//LittleFS Size -- Total: 196608 Used: 172032 Free: 24576
var InUpdate=0, UpdatePending=0;
var spc="&nbsp;&nbsp;&nbsp;&nbsp;";
var minmem=200000,maxmem=0,optchanged=2,update_interval=0,current_bt_status;
var max_scan=45000; max_scan_opt=74000;
//max_scan=50000; max_scan_opt=100000;

var update_speed_fast=1,update_speed_slow=600;

function PendingUpdate(){
	UpdatePending=Math.floor(Math.random() * 65535);
	console.log("Pending Update NONCE:"+UpdatePending);
	$.get( "/pend?v="+UpdatePending);
}

try {
var scan_s = document.getElementById('scanrate');
noUiSlider.create(scan_s, {
    start: [20000],	step: 1000, connect: 'lower', range: {'min': 10000,'max':max_scan_opt},
	format: {
        to: function (value) {return parseInt(value).toLocaleString();},
        from: function (value) {return Number(value.replace(',', ''));}
	}
});

var size_s = document.getElementById('scansize');
noUiSlider.create(size_s, {
    start: [20],step: 2,    connect: 'lower', range: {'min': 0,'max': 100},
	format: {
        to: function (value) {return parseInt(value)+"%";},
        from: function (value) {return Number(value.replace('%', ''));}
	}
});

var blank_s = document.getElementById('blank');
noUiSlider.create(blank_s, {
    start: [4],	step: 1, connect: 'lower', range: {'min': 0,'max': 16},
	format: {
        to: function (value) {return parseInt(value);},
        from: function (value) {return Number(value);}
	}
});

var bright_s = document.getElementById('brightness');
noUiSlider.create(bright_s, {
    start: [50],step: 5, connect: 'lower', range: {'min': 0,'max': 100	},
	format: {
        to: function (value) {return parseInt(value)+"%";},
        from: function (value) {return Number(value.replace('%', ''));}
       }
});

var xoffset_s = document.getElementById('xoffset');
noUiSlider.create(xoffset_s, {
    start: [0],step: 5, connect: 'lower',   range: {'min': -800,'max': 800},
	format: {
        to: function (value) {return parseInt(value).toLocaleString();},
        from: function (value) {return Number(value.replace(',', ''));}
	}
});

var yoffset_s = document.getElementById('yoffset');
noUiSlider.create(yoffset_s, {
    start: [0], step: 5,  connect: 'lower', range: {'min': -800,'max': 800},
	format: {
        to: function (value) {return parseInt(value).toLocaleString();},
        from: function (value) {return Number(value.replace(',', ''));}
	}
});

var color_s = document.getElementById('color');
noUiSlider.create(color_s, {
    start: [50], step: 1, connect: 'lower', range: {'min': 1,'max': 100},
	format: {
        to: function (value) {return parseInt(value).toLocaleString();},
        from: function (value) {return Number(value.replace(',', ''));}
	}
});

var freq_s = document.getElementById('freq');
noUiSlider.create(freq_s, {
    start: [0],	step: 1, connect: 'lower', range: {'min': -30,'max': 100},
	format: {
        to: function (value) {
        	var f=parseInt(value);
        	if (f<0) return (-f)+"(slow)";
        	else return f+"(fast)";},
        from: function (value) {return Number(value.replace(',', ''));}
	}
});

var frame_s = document.getElementById('frame');
noUiSlider.create(frame_s, {
    start: [0],	step: 1, connect: 'lower', range: {'min': 0,'max': 100},
	format: {
        to: function (value) {
        	var f=parseInt(value);
        	return f;
        	//if (f<0) return (-f)+"(slow)"; else return f+"(fast)";},
        },
        from: function (value) {return Number(value.replace(',', ''));}
	}
});



// values: Current slider values (array);
// handle: Handle that caused the event (number);
// unencoded: Slider values without formatting (array);
// tap: Event was caused by the user tapping the slider (boolean);
// positions: Left offset of the handles (array);
// noUiSlider: slider public Api (noUiSlider);
scan_s.noUiSlider.on('slide', function(values){$("#scan_val").html("Target: "+values[0]+"<br>Accuracy: Pending");});
scan_s.noUiSlider.on('change', function(values, handle, unencoded){
 	PendingUpdate();
 	$.get( "/scanrate?v="+unencoded[0]);
 });


size_s.noUiSlider.on('update', function(values){$("#size_val").html(values[0]);});
size_s.noUiSlider.on('change', function(values, handle, unencoded){
	$("#size_val").html(values[0]);
	PendingUpdate();
	$.get( "/size?v="+unencoded[0]);
});

blank_s.noUiSlider.on('update', function(values){$("#blank_val").html(values[0]);});
blank_s.noUiSlider.on('slide', function(values, handle, unencoded){
	$("#blank_val").html(values[0]);
	PendingUpdate();
	$.get( "/blank?v="+unencoded[0]);
});

bright_s.noUiSlider.on('update', function(values){$("#bright_val").html(values[0]);});
bright_s.noUiSlider.on('change', function(values, handle, unencoded){
	$("#bright_val").html(values[0]);
	PendingUpdate();
	$.get( "/bright?v="+unencoded[0]);
});

xoffset_s.noUiSlider.on('update', function(values){$("#xoffset_val").html(values[0]);});
xoffset_s.noUiSlider.on('change', function(values, handle, unencoded){
	$("#xoffset_val").html(values[0]);
	PendingUpdate();
	$.get( "/offset?axis=x&v="+parseInt(unencoded[0]));
});

yoffset_s.noUiSlider.on('update', function(values){$("#yoffset_val").html(values[0]);});
yoffset_s.noUiSlider.on('change', function(values, handle, unencoded){
	$("#yoffset_val").html(values[0]);
	PendingUpdate();
	$.get( "/offset?axis=y&v="+parseInt(unencoded[0]));
});

color_s.noUiSlider.on('slide', function(values, handle, unencoded){
	$("#color_val").html(values[0]);
	$.get( "/color?v="+parseInt(unencoded[0]));
});

freq_s.noUiSlider.on('slide', function(values, handle, unencoded){
	$("#freq_val").html(values[0]);
	 $.get( "/freq?v="+parseInt(unencoded[0]));
});

frame_s.noUiSlider.on('update', function(values, handle, unencoded){
	$("#frame_val").html(values[0]);
	 $.get( "/frame?v="+parseInt(unencoded[0]));
});

blank_s.noUiSlider.on('start', function(){InUpdate++;});
blank_s.noUiSlider.on('end', function(){InUpdate--;});
scan_s.noUiSlider.on('start', function(){InUpdate++;});
scan_s.noUiSlider.on('end', function(){InUpdate--;});
size_s.noUiSlider.on('start', function(){InUpdate++;});
size_s.noUiSlider.on('end', function(){InUpdate--;});
bright_s.noUiSlider.on('start', function(){InUpdate++;});
bright_s.noUiSlider.on('end', function(){InUpdate--;});
xoffset_s.noUiSlider.on('start', function(){InUpdate++;});
xoffset_s.noUiSlider.on('end', function(){InUpdate--;});
yoffset_s.noUiSlider.on('start', function(){InUpdate++;});
yoffset_s.noUiSlider.on('end', function(){InUpdate--;});
color_s.noUiSlider.on('start', function(){InUpdate++;});
color_s.noUiSlider.on('end', function(){InUpdate--;});
freq_s.noUiSlider.on('start', function(){InUpdate++;});
freq_s.noUiSlider.on('end', function(){InUpdate--;});
frame_s.noUiSlider.on('start', function(){InUpdate++;});
frame_s.noUiSlider.on('end', function(){InUpdate--;});
} catch{}

function PatternButtons() {
   	var j=$('#plist').html(); // get pattern list JSON from inside HTML page
   	$('#plist').html(""); // prepare to receive actual buttons
   	j=JSON.parse(j);
   	var i;
    for (i=1;i<j.length-1;i++) {
      	var split=j[i].indexOf('/');
      	var fname=j[i].substr(split+1);
		fname=fname.replace(/.ild/gi, '');
       	var line="<button data-params='s=t&p="+(i-1)+"' type='button' class='changestate btn btn-success'>"+fname+"</button>\n&nbsp;&nbsp;&nbsp;";
	   	$('#plist').append(line);
   	}
}

$(document).ready(function() {

	PatternButtons();

	$(".noUi-connect").css("background","#7c5bb1");
	$(".slider").css("width","350px");

	if (localStorage.preview==undefined || localStorage.preview=='off') {
		localStorage.preview='off';
		$("#screen,.preview").hide();
		$("#preview").html("Preview Window [off]");
	}
	else {
		$("#screen,.preview").show();
		$("#preview").html("Preview Window [on]");
	}

	$( document ).on( "click", "#optimize", function(e) {
		e.preventDefault();
		$.get( "/optimize", function( data ) {	});
	});

	$( document ).on( "click", ".saveproj", function(e) {
		e.preventDefault();
		$.get("/saveproj?action="+$(this).data("action"), function( data ) {	});
	});

	$( document ).on( "click", "#preview", function(e) {
		e.preventDefault();
		if (localStorage.preview=='on') {
			g_file = 0;
			localStorage.preview="off";
			$("#screen,.preview").hide();
			$(this).html("Preview Window [off]");
		}
		else {
			$("#screen,.preview").show();
			localStorage.preview="on";
			$(this).html("Preview Window [on]");
		}
	});

	$( document ).on( "click", "#shutter", function(e) {
		e.preventDefault();
		$.get( "/shutter", function( data ) {	});
	});

	$( document ).on( "click", "#reboot", function(e) {
		$.get( "/reboot", function( data ) {});
	});
	$( document ).on( "click", "#flipoled", function(e) {
		e.preventDefault();
		$.get( "/flip", function( data ) {	});
	});


	$( document ).on( "click", "#shapes", function(e) {
		$("#shapesbeams").toggle();
	});


	$( document ).on( "click", ".details", function(e) {
		e.preventDefault();
		var stat=$("#pointnum").data("status");
		if (stat=="on") {
			stat="off";
			$(".details").html("Show Details");
		}
		else {
			stat="on";
			$(".details").html("Hide Details");
		}
		$("#pointnum").data("status",stat);
	});

	$( document ).on( "click", ".sdcard ", function(e) {
		e.preventDefault();
		var html="",loop=1,dirname=$(this).data("path");
		var haswav=0;
		$("#sddiv").html("<br>Reading SD Card..."+$(this).data("path")).show();
		$("#urldiv").hide();
		$.get("/sd?path="+dirname+"&up="+$(this).data("parent"), function( data ) {
			var readme="",json=JSON.parse(data);
			if (json.d!="/") html="<button data-parent='"+json.p+"' data-path='"+json.p+"' type='button' data-json=1 class='sdcard btn btn-light'>"+json.p+"</button>&nbsp;&nbsp;\n";
			html+="<button data-parent='"+json.p+"' data-path='"+json.d+"' type='button' data-json=1 class='sdcard btn btn-light'>"+json.d+"</button>\n<br>";
			json.i.sort();
			json.i.forEach((e) => {
				var sn=e.substr(1);
				var fd=e.substr(0,1);
				if (fd=="R") readme="<div class='stats'>"+sn.substr(1)+"</div>";
				else if (fd=="m") html="<div class='stats'>INTERNAL MEMORY FULL -- Please hit E-STOP and try again</div>"+html;
				else if (fd=="d") html+="<button data-parent='"+json.d+"' data-path='"+((json.d=="/")?sn:json.d+sn)+"' type='button' data-json=1 class='sdcard btn btn-info'>"+sn+"</button>&nbsp;&nbsp;&nbsp;\n";
				else {
					var sz=sn.indexOf(":");
					haswav=haswav+Math.max(0,sn.indexOf(".wav"))+Math.max(0,sn.indexOf(".WAV"));
					console.log("haswav:"+haswav);
					fn=sn.substr(0,sz);
					sz=sn.substr(sz+1);
					sn=fn.replace(/.ild/gi, '');
					sn=sn.replace(/.wav/gi, '');
					if (sz>0) sz=" ("+sz+"mb)";else sz="";
					if (sn.indexOf("!!")==-1)
						html+="<button data-sn='"+sn+"' data-url='"+json.d+"/"+fn+"' data-json=1 type='button' class='loadurl btn btn-dark'>"+sn+sz+"</button>&nbsp;&nbsp;&nbsp;";
					else
						html+="<br>Source: <a class='stats' target=_blank href='https://"+sn.substr(2)+"'>"+sn.substr(2)+"</a><br>";
				}
			});
			html+=readme;
			if (haswav>0) html+="<Br><button data-path='"+dirname+"' type='button' data-json=1 class='playall btn btn-success'>Play All</button>&nbsp;&nbsp;"+
			"<button data-params='s=n&p=prev' type='button' class='changestate btn btn-primary'>&lt;&lt;</button>&nbsp;&nbsp;"+
			"<button data-params='s=n&p=pause' type='button' class='changestate btn btn-primary'>&#2405;</button>&nbsp;&nbsp;"+
			"<button data-params='s=n&p=play' type='button' class='changestate btn btn-primary'><b>&gt;</b></button>&nbsp;&nbsp;"+
			"<button data-params='s=n&p=next' type='button' class='changestate btn btn-primary'>&gt;&gt;</button>&nbsp;&nbsp;"+
			"<button data-params='s=n&p=stop' type='button' class='changestate btn btn-primary'>&#9744;</button>\n";
			$("#sddiv").html(html);
			clearInterval(loop);
			loop=1;
		});
		loop=setInterval(function() {$("#sddiv").html($("#sddiv").html()+".");},250);
		setTimeout(function() {if (loop!=1) {$("#sddiv").html("Error receiving SD Directory info. Click E-stop and please try again.");clearInterval(loop);}},10000);
	});

	$( document ).on( "click", ".resetoffset", function(e) {
		var of=$(this).data("axis");
		console.log(of);
		PendingUpdate();
		$("#"+of+"offset_val").html("0");
		if (of=="x") $.get( "/offset?axis=x&v=0");
		if (of=="y") $.get( "/offset?axis=y&v=0");
	});

	$( document ).on( "click", ".estop", function(e) {
		e.preventDefault();
		var el=$(this);
		console.log(el.attr("href"));
		$.get( "/state?s=s&p=0&d=e", function( data ) {
			window.location.href=el.attr("href");
		});
	});

	$( document ).on( "click", ".changestate", function(e) {
		e.preventDefault();
		$.get( "/state?"+$(this).data("params"), function(data){});
	});

	$( document ).on( "click", ".playall", function(e) {
		e.preventDefault();
		if (current_bt_status!="-")
		$("#pointnum").html("<br><h2 style='color:red;'>Please disable Bluetooth on the ILDAC for best WAV performance.<br>See link below</h2>");
		SetStatSpeed(update_speed_slow);
		setTimeout(function(){update();},1000);
		$.get( "/play?path="+$(this).data("path"), function(data){});
	});



	$( document ).on( "click", ".loadurl", function(e) {
		maxpoints=0;
		g_file = 0;
		ctx.fillRect(0, 0, size, size);
		ctx.fillStyle = "yellow";
		ctx.font = "15px Arial";
		ctx.fillText("Loading "+$(this).data("sn"), 5, 50);
		ctx.fillStyle = "black";
		var filename=$(this).data("url");
		var url=filename;
		if ($(this).data("extern")!="1") {url="/ilda?v="+filename;}
		if (filename.indexOf(".wav")>0 || filename.indexOf(".WAV")>0) {
			if (current_bt_status!="-") $("#pointnum").html("<br><h2 style='color:red;'>Please disable Bluetooth on the ILDAC for best WAV performance.<br>See link below</h2>");
			$("#showitnow").data("params","s=w&p="+filename);
			$("#download").attr("href","").attr("download","").html("").hide();
			setTimeout(function(){SetStatSpeed(update_speed_slow);},10);
			setTimeout(function(){update();},1000);
	}
		else {
			SetStatSpeed(update_speed_fast);
			$("#showitnow").data("params","s=i&p="+filename).show();
			$("#download").attr("href",url).attr("download",filename.substring(1)).html("Download "+$(this).data("sn")).show();
		}
		if (localStorage.preview=="off") {
			$("#showitnow").trigger("click");
			return;
		}
		console.log(url);
		ensureVisible($("#screen"));
		//var si=setInterval(console.log("setting timeout"),1000);
		$.ajax({
			url: url,
			dataType: "arraybuffer",
			success: function(response) {
				//console.log("received data:", response);
				var bytebuffer = new Uint8Array(response);
				//console.log("Bytebuffer",bytebuffer);
				var bytes = bytebuffer.toByteArray();
				//console.log("ByteArray:",bytes);
				ILDA.Reader.fromByteArray(bytes, function(data) {
					//var typ=data.sections[0].type;
					g_file = data;
					//console.log("g_file",g_file);
				});
				//clearInterval(si);
			},
			xhr: function() {
	        	xhr = new XMLHttpRequest();
	        	var flip="=";
	        	xhr.addEventListener('progress', function(event) {
	        		var load,tot,pct;
	        		load=event.loaded;
	        		tot=event.total;
	        		pct=Math.round(100*load/tot,0);
	        		if (flip=='-') flip='+'; else flip='-';
		        	if (pct%5==0) {
		        		//console.log("loading at "+pct+"%");
						ctx.fillStyle = "black";
						ctx.fillRect(15, 130, 220, 30);
	  					ctx.fillStyle = "lightgreen";
						ctx.fillText("Loading: "+load.toLocaleString()+ " "+pct+"% ", 15, 145);
						ctx.fillStyle = "black";
					} else {
		       			ctx.globalAlpha=alpha;
						ctx.fillStyle = "black";
						ctx.fillRect(0, 130, 15, 15);
	  					ctx.fillStyle = "white";
						ctx.fillText(flip, 0, 145);
						ctx.fillStyle = "black";
					}
	            	//console.log("loading...",event,event.loaded.toLocaleString());
	            	ctx.globalAlpha=alpha;
    	    	});
        		return xhr;
	    	}});

/*		$.get(url, function(data) {
			console.log("received data", data);
			var bytebuffer = new Uint8Array(data);
			console.log(bytebuffer);
			var bytes = bytebuffer.toByteArray();
			var sbytes=""+bytes+"  ";
			//$("#urloutput").html(sbytes.substring(0,5000));
			ILDA.Reader.fromByteArray(bytes, function(data) {
				var typ=data.sections[0].type;
				if (typ==4 || typ.type==5) {
					ctx.fillStyle = "yellow";
					ctx.fillText("ILDA Format "+typ+" not", 5, 100);
					ctx.fillText("supported in Preview", 5, 115);
					ctx.fillStyle = "black";
					$("#showitnow").trigger("click");
					console.log("Formats 4 and 5 note supported");
					data=0;
				}
				else {
					g_file = data;
				 	console.log("g_file",g_file);
				}
			});
		},
		"arraybuffer");
*/

	});

/*	$( document ).on( "click", "#debug", function(e) {
		e.preventDefault();
		$.get( "/debug", function( data ) {	});
	});
*/	$( document ).on( "click", ".toggle", function(e) {
		e.preventDefault();
		$.get( "/"+$(this).data("option")+"?v="+$(this).data("setting"), function(data){});
	});

	$( document ).on( "click", ".invert", function(e) {
		e.preventDefault();
		$.get( "/invert?axis="+$(this).data("action"), function(data){	});
	});

	function ensureVisible(div) {
		div.each(function () { div[0].scrollIntoView(); });
	};

	$( document ).on( "click", "#pausestats", function(e) {
		e.preventDefault();
		if ($(this).data("pause")==0) SetStatSpeed(update_speed_fast);  // OFF turns to FAST
		else if ($(this).data("pause")==1) SetStatSpeed(0); 			// SLOW turns to OFF
		else if ($(this).data("pause")==2) SetStatSpeed(update_speed_slow); // FAST turns to  SLOW
	});

	function SetStatSpeed(secs){
		clearInterval(update_interval);
		if (secs>0) {
			update_interval=setInterval(function(){
				update();
			},secs*1000);
		}
/*		OFF: DANGER  --> FAST/SECONDARY
		SLOW: WARNING --> OFF/DANGER
		FAST: SECONDARY -- SLOW/WARNING
		*/
		if (secs==0) 				 $("#pausestats").data("pause",0).html("Update: Click" ).addClass("btn-danger").removeClass("btn-warning").removeClass("btn-secondary");
		if (secs==update_speed_slow) $("#pausestats").data("pause",1).html("Update: Slow").addClass("btn-warning").removeClass("btn-secondary").removeClass("btn-danger");
		if (secs==update_speed_fast) $("#pausestats").data("pause",2).html("Update: Fast").addClass("btn-secondary").removeClass("btn-danger").removeClass("btn-warning");
		//else $("#pausestats").html("Pause Stats").data("pause",0);
		console.log("Setting refresh delay to "+secs+" seconds. pause.data="+$("#pausestats").data("pause"));
	}

//	$("#showitnow").trigger("click");
	SetStatSpeed(update_speed_fast);

	function update() {
		$("#in_update").html("UpdatePending="+UpdatePending+ " InUpdate="+InUpdate).show();
		if (InUpdate==0) {
			InUpdate++;
		$.ajax({
			type: 'get',
			dataType: 'json',
			url: '/update',
			complete:  function(response) {
				//console.log(response);
				//console.log(response["responseText"]);
				try {
					var reply=JSON.parse(response.responseText);
				}
				catch {
					$("#update").html("JSON receive [complete(1)] error from ILDAC32");
					return;
				}
				var ppsa=(100*reply.pps/reply.scan).toFixed(2);
				$("#scan_val").html("Target: "+reply.scan.toLocaleString()+
					" Actual: "+reply.pps.toLocaleString()+
					" <br>Accuracy: "+ppsa+"%");
				try {
					var sd="";
					if (reply["sd"]>0) {
						sd=" size: <span class=stats>"+reply["sd"].toLocaleString()+" Mb</span>"+" Free: <span class=stats>"+(reply["sd"]-reply["sdu"]).toLocaleString()+" Mb</span>";
						$(".sdcard").show();
					}
					else {
						sd="<span class=stats>disabled</span>";
						$(".sdcard").hide();
						$(".preview").hide();
						$("#preview").html("Preview Window [off]");
					}
					if (reply.secs<2) {minmem=100000,maxmem=0;}
					minmem=Math.min(minmem,reply.mem);
					maxmem=Math.max(maxmem,reply.mem);

					//var secs=(reply.roll*71.58278827*60)+reply.secs;
					var secs=reply.ms/1000;
					const days = Math.floor(secs / 86400);
					const hours = Math.floor(secs / 3600) %24 ;
					const minutes = Math.floor(secs / 60) % 60;
					const seconds = Math.floor(secs % 60);
					var time="";updatehtml="Javascript Error - check console";
					if (days>0) time=days+"d ";
					if (hours>0) time+=hours+"h ";
					if (minutes>0) time+=minutes+"m ";
					if (seconds>0) time+=seconds+"s ";
					if (reply["delay"]<0) reply["delay"]="Point Draw <span class=stats>"+(-reply["delay"])+" &#181s</span>";
					else reply["delay"]="PPS Delay: <span class=stats>"+(reply["delay"])+"</span>";
					updatehtml=
					spc+"Current Pattern: <span class=stats>"+reply["pat"].replace("/","").replace(".ild","")+"</span> Uptime: <span class=stats>"+time+"</span><br>"+
					spc+"Free Memory: <span class=stats>"+reply["mem"].toLocaleString()+"</span>"+
					" Min/Max: <span class=stats>"+minmem.toLocaleString()+"/"+maxmem.toLocaleString()+"</span><br>"+
					//" Stack High Water Mark: <span class=stats>"+reply.stk.toLocaleString()+"</span><br>"+
					spc+"SD Card: "+sd+spc+"Shutter: <span class=stats>"+(reply.sh?"Closed":"Open")+"</span><br>"+
					//spc+"Internal Storage: <span class=stats>"+reply["fs"].toLocaleString()+" b </span>"+
					//" Free: <span class=stats>"+(reply["fs"]-reply["fs_used"]).toLocaleString()+" b</span>"+
					spc+
					"Firmware: <span class=stats>"+reply["ver"]+"</span>"+
					" js: <span class=stats>"+ver+"</span> "+
					" html: <span class=stats>"+$("#htmlver").data("version")+"</span>"+
					"<br>"+
					spc+"WiFi SSID: <span class=stats>"+reply["ssid"]+"</span> BLE Device: <span class=stats>"+((reply.dev=="-")?"Disabled":reply.dev)+"</span><Br>"+
					spc+reply["delay"]+" Console: <span class=stats>"+(reply["con"]=="1"?"On":"Off")+"</span>";
					current_bt_status=reply["dev"];
				} catch {
					updatehtml="JSON receive [complete(2)] error from ILDAC32";
				}
				try {
					if (reply.int>3) updatehtml+=" Interrupts: <span class=stats>"+reply.int+"</span>";
					//if (reply.sk>0) updatehtml+=" Points Skipped: <span class=stats>"+parseInt(reply.sk)+"%</span>";
					if (reply.wav>0) updatehtml+=" WAV Progress: <span class=stats>"+reply.wav+"%</span>";
					if (reply.wav==-1 && $("#pausestats").data("pause")!=2) SetStatSpeed(update_speed_fast);
					if (reply.wav!=-1 && $("#pausestats").data("pause")!=1) SetStatSpeed(update_speed_slow);
					//updatehtml+=" Halt: <span class=stats>"+reply.h+"</span>";
				}
				catch {updatehtml+="No Wave Data";}
				$("#update").html( updatehtml+"<br>");

				if (UpdatePending>0 && reply["apu"]!=UpdatePending) {return;}
				if (UpdatePending>0 && reply["apu"]==UpdatePending) {$.get( "/pend?v=0");UpdatePending=0;}
				if (reply["secs"]>1) {
					try {
					Update(scan_s.noUiSlider,"scan",reply);
					Update(size_s.noUiSlider,"size",reply);
					Update(bright_s.noUiSlider,"br",reply);
					Update(blank_s.noUiSlider,"bl",reply);
					Update(xoffset_s.noUiSlider,"xo",reply);
					Update(yoffset_s.noUiSlider,"yo",reply);
					Update(frame_s.noUiSlider,"fr",reply);
					} catch{}
				}
				if (reply["opt"]!=optchanged) {
					try {
						if (reply["opt"]==false) {
							$("#optimize").removeClass("btn-warning").addClass("btn-dark").html("Point Optimzer (off)");
							var rval=scan_s.noUiSlider.get(true);
							if (rval>max_scan) rval=max_scan;
							scan_s.noUiSlider.updateOptions( {step: 500, connect: 'lower', range: {'min': 10000,'max':max_scan}},true); // Boolean 'fireSetEvent'
							//PendingUpdate();
							$.get( "/scanrate?v="+rval);
						}
					else {
						$("#optimize").addClass("btn-warning").removeClass("btn-dark").html("Point Optimzer (on)");
						scan_s.noUiSlider.updateOptions({ step: 1000,connect: 'lower', range: {'min': 10000,'max':max_scan_opt}},true); // Boolean 'fireSetEvent'
					}
					} catch{}
					optchanged=reply["opt"];
				}



			},
			success: function (response) { },
			error:function(XMLHttpRequest,status,error){
				$("#update").html("JSON receive error [error()] from ILDAC32. Rebooting?");
				console.log("AJAX error "+error+status);
			}
		});
	InUpdate--;
	}
	}
function Update(slider,attrib,reply) {
	if (attrib=="freq" || attrib=="color") return; // neither of these are in the json stream, no need to update
	try {
	if (parseInt(slider.get(true))!=parseInt(reply[attrib])) {
		//console.log(attrib+" Slider Val: "+parseInt(slider.get(true))+" Reply Val: "+reply[attrib]);
		PreventCascade=true;
		slider.set(reply[attrib]);
		PreventCascade=false;
	}
	} catch{}
}

});