	var xhr;
	var g_file = new ILDA.File();
	var size=300;
	var speed = 300;
	var alpha=1;
	var maxpoints=0;
	var section = 0;
	var point = 0;
	var defaultcolors = [
		'#F00','#F10','#F20','#F30','#F40','#F50','#F60','#F70',
		'#F80','#F90','#FA0','#FB0','#FC0','#FD0','#FE0','#FF0',
		'#FF0','#EF0','#CF0','#AF0','#8F0','#6F0','#4F0','#2F0',
		'#0F0','#0F2','#0F4','#0F6','#0F9','#0FB','#0FD','#0FF',
		'#0EF','#0CF','#0AF','#08F','#07F','#05F','#03F','#01F',
		'#00F','#20F','#40F','#60F','#80F','#A0F','#C0F','#E0F',
		'#F0F','#F2F','#F4F','#F6F','#F8F','#FAF','#FCF','#FEF',
		'#FFF','#FEE','#FCC','#FAA','#F88','#F66','#F44','#F22'
	];

	Uint8Array.prototype.toByteArray = function () { return Array.prototype.slice.call(this, 0); }

	var can = document.getElementById('canvas1');
	var ctx = can.getContext('2d');

	var lastpoint = { x: 0, y: 0 };
	function stepLaser () {
		if (section >= g_file.sections.length) {
			section = 0;
			point = 0;
		}
		if (section < g_file.sections.length) {
			var seg = g_file.sections[section];
			if (point < seg.points.length) {
				var pt = seg.points[point];
				var newpoint = {
					x: (size/2) + ((size/2)-10) * pt.x / 32768,
					y: (size/2) - ((size/2)-10) * pt.y / 32768
				}
				//console.log('x', newpoint.x,'y',newpoint.y);
				if (!pt.blanking) {
					if (pt.color<64) ctx.strokeStyle = defaultcolors[pt.color % defaultcolors.length];
					else ctx.strokeStyle =pt.color;
					//ctx.strokeStyle = defaultcolors[pt.color % defaultcolors.length];
					ctx.beginPath();
					//if (lastpoint.x==newpoint.x) newpoint.x++;
					if (lastpoint.y==newpoint.y && lastpoint.x==newpoint.x) newpoint.y++;
				    ctx.moveTo(lastpoint.x, lastpoint.y);
				    ctx.lineTo(newpoint.x, newpoint.y);
				    ctx.closePath();
				    ctx.stroke();
			    }

				if ($("#pointnum").data("status")=="on") {
				    $("#pointnum").html(spc+"Total Frames "+ g_file.sections.length+"<br>"+spc+"Frame #"+section+"<br>"+spc+"Point # "+point+"<br>"+spc+"Max Points: "+maxpoints+"<br>"+spc+"X: "+pt.x + "<br>"+spc+"Y:"+pt.y +
				    "<br>"+spc+"Color Index: "+pt.color% defaultcolors.length +
				    "<br>"+spc+"HEX Color: <span style='color:"+ctx.strokeStyle+"'>"+ctx.strokeStyle.toUpperCase()+"</span>");
				   }


			    maxpoints=Math.max(point,maxpoints);
   			    lastpoint.x = newpoint.x;
			    lastpoint.y = newpoint.y;
				point ++;
			} else {
				$("#pointnum").html(spc+"Total Frames "+ g_file.sections.length+"<br>"+spc+"Frame #"+section+"<br>"+spc+"Max Points: "+maxpoints);
			    section ++;
				point = 0;
			}
		}
	}

	function moveLaser () {
		if (g_file==0) return;
		// fade background a bit...
		ctx.globalAlpha = 0.1;
		ctx.fillStyle = '#000';
		ctx.fillRect(0, 0, size, size);
		ctx.globalAlpha = alpha;
		for (var i=0; i<speed; i++ )
			stepLaser();
	}
	setInterval(moveLaser, 25);

$(document).ready(function() {

function ensureVisible(div) {
	div.each(function () { div[0].scrollIntoView(); });
};

	$("#speedval").html(speed);
	$("#sizeval").html(size+"px");
	$("#showitnow").hide();
	$("#download").hide();

	$( document ).on( "input", "#speed,#size", function(e) {
		if ($(this).attr("id")=="speed") {
			speed=$(this).val();
			$("#speedval").html(speed);
		}
		if ($(this).attr("id")=="size")  {
			size=$(this).val();
			$("#sizeval").html(size+"px");
			var css="height:"+size+"px; width:"+size+"px;";
			$("#canvas1").attr("height",size).attr("width",size);
		}
	});

	var css="height:"+size+"px; width:"+size+"px;";
	$("#canvas1").attr("height",size);
	$("#canvas1").attr("width",size);
});


